//----------------------------------------------------------------------

#define GTcomLine 0x80000001

void GTexeLine(){
  int x1=GTfifoGet() ;
  int y1=GTfifoGet() ;
  int x2=GTfifoGet() ;
  int y2=GTfifoGet() ;
  int cc=GTfifoGet() ;
  if(x1<0) { return ; }
  if(x1>=480) { return ; }
  if(x2<0) { return ; }
  if(x2>=480) { return ; }
  
  if(y1<0){ return ; }
  if(y1>=320) { return ; }
  if(y2<0){ return ; }
  if(y2>=320) { return ; }
  tftLine(x1,y1,x2,y2,cc) ;
  }



void GTputLine(int x1,  int y1, int x2, int y2, int cc){
  GTfifoPut(GTcomLine) ;
  GTfifoPut(x1) ;
  GTfifoPut(y1) ;
  GTfifoPut(x2) ;
  GTfifoPut(y2) ;
  GTfifoPut(cc) ;   
  }

#define GTcomPutc 0x80000002

void GTexePutc(){
  termPutc(GTfifoGet()) ;
  }

void GTputPutc(char cc){
  GTfifoPut(GTcomPutc) ;
  GTfifoPut(cc) ;
  }

#define GTcomPrint 0x80000003

void GTexePrint(){
  int c ;
  while(c=GTfifoGet()){
    termPutc(c) ;
    } 
  }

void GTputPrint(char *cp){
  GTfifoPut(GTcomPrint) ;
  char c;
  while ( (c = *(cp++)) ) { 
     GTfifoPut(c) ;
    }
  GTfifoPut(0) ;
  }

#define GTcomRemark 0x80000004

void GTexeRemark(){
  int c ;
  while(c=GTfifoGet()){
    printf("%c",c) ;
    } 
  }

void GTputRemark(char *cp){
  GTfifoPut(GTcomRemark) ;
  char c;
  while ( (c = *(cp++)) ) { 
     GTfifoPut(c) ;
     //printf("[%c]",c) ;
    }
  GTfifoPut(0) ;
  }


#define GTcomCrlf 0x80000005

void GTexeCrlf(){
  termCrlf() ;
  }

void GTputCrlf(){
  GTfifoPut(GTcomCrlf) ;
  }  

#define GTcomRemarkChr 0x80000006

void GTexeRemarkChr(){
  printf("%c",GTfifoGet()) ;
  }

void GTputRemarkChr(char cc){
  GTfifoPut(GTcomRemarkChr) ;
  GTfifoPut(cc) ;
  }

int cnt1=0 ;

void GTexec(){
  while(1){
    cnt1++ ;
    if(cnt1>2000){ 
      cnt1=0 ;
      //printf("<alive>") ;
      LCD_Clear(0) ; }
    int command=GTfifoGet() ;
    if(command==GTcomLine){ GTexeLine() ; }
     else if(command==GTcomPutc){ GTexePutc() ; }
     else if(command==GTcomPrint){ GTexePrint() ; }
     else if(command==GTcomRemark){ GTexeRemark() ; }
     else if(command==GTcomCrlf){ GTexeCrlf() ; }
     else if(command==GTcomRemarkChr){ GTexeRemarkChr() ; }
    }
  }

void core1_entry(){
  printf("core1 running\n") ;
  GTexec() ;
  }

//----------------------------------------------------------------------